// Datei: pwmtest.c
//
// hk@holger-klabunde.de
// www.holger-klabunde.de
// 03.05.2002
// Compiler CC5x

#include "prozess.h"      // Der verwendete Prozessor
#include "protos.h"

#include "delay.c"
#include "bin2bcd8.c"
#include "lcd.c"
 
//*******************************************************
// Hauptprogramm
//*******************************************************
void main()
{
 unsigned char i;
 
 CMCON=0b00000111;  //Comparator inaktiv

 CLRWDT;
 //Takt des PIC 4MHz, ein Zyklus = 1us
 OPTION=0b11000001; //Pullups off,Prescaler auf TMR0, 1:4

 TRISB=0b00000000;  //0=Ausgang, 1=Eingang
 PORTB=0b00000000;  //Port einmal schreiben

 TRISA=0b00000;     //0=Ausgang, 1=Eingang
 PORTA=0b00000000;  //Port einmal schreiben
 
 LCDInit();
 LCDCls();
 LCDWrite("PIC-Minimodul");
 LCDPos(2,1);
 LCDWrite("PWM Testprogramm");

 CCP1CON=0b00001100; //PWM Modul an
 T2CON=0b00000100; //Pre- und Postscaler 1:1, Timer2 an

 while(1) // Programm-Endlosschleife
  {
   PR2=0xFF;     //ergibt PWM Frequenz 3,9kHz bei 4MHz und Prescaler 1:1
   CCPR1L=0x80;   //Duty Cycle 50% bei 10Bit Auflsung
   for(i=0; i<20; i++) Delay1ms(250); //Warte 5s
   
   PR2=0x7F;     //ergibt PWM Frequenz 7,8kHz bei 4MHz und Prescaler 1:1
   CCPR1L=0x40;   //Duty Cycle 50% bei 9Bit Auflsung
   for(i=0; i<20; i++) Delay1ms(250); //Warte 5s

   PR2=0x3F;     //ergibt PWM Frequenz 15,6kHz bei 4MHz und Prescaler 1:1
   CCPR1L=0x20;   //Duty Cycle 50% bei 8Bit Auflsung
   for(i=0; i<20; i++) Delay1ms(250); //Warte 5s

   PR2=0x1F;     //ergibt PWM Frequenz 31,2kHz bei 4MHz und Prescaler 1:1
   CCPR1L=0x10;   //Duty Cycle 50% bei 7Bit Auflsung
   for(i=0; i<20; i++) Delay1ms(250); //Warte 5s

   PR2=0x0F;     //ergibt PWM Frequenz 62,5kHz bei 4MHz und Prescaler 1:1
   CCPR1L=0x08;   //Duty Cycle 50% bei 6Bit Auflsung
   for(i=0; i<20; i++) Delay1ms(250); //Warte 5s

   PR2=0x07;     //ergibt PWM Frequenz 125,0kHz bei 4MHz und Prescaler 1:1
   CCPR1L=0x04;   //Duty Cycle 50% bei 5Bit Auflsung
   for(i=0; i<20; i++) Delay1ms(250); //Warte 5s

   PR2=0x03;     //ergibt PWM Frequenz 250,0kHz bei 4MHz und Prescaler 1:1
   CCPR1L=0x02;   //Duty Cycle 50% bei 4Bit Auflsung
   for(i=0; i<20; i++) Delay1ms(250); //Warte 5s

   PR2=0x01;     //ergibt PWM Frequenz 500,0kHz bei 4MHz und Prescaler 1:1
   CCPR1L=0x01;   //Duty Cycle 50% bei 3Bit Auflsung
   for(i=0; i<20; i++) Delay1ms(250); //Warte 5s
  } //while(1) Endlosschleife
}
