// Datei: interupt.c
// PIC Interrupts
//
// hk@holger-klabunde.de
// www.holger-klabunde.de
// 05.05.2002
// Compiler CC5X

#include <int16CXX.H>

#pragma origin 4  //Interruptvektor vom PIC

#define SAMPLES 36 //Anzahl der Werte pro Kurve

unsigned char shapecount;
unsigned char sbuf,tmp;

//Daten fr eine Sinuswelle (alle 10 Grad ein Wert)
//     255*(1+sin(grad))/2
const unsigned char data[]={ 128,150,171,191,210,225,238,247,253,255, //0-90
                             253,247,238,225,210,191,171,150,128,     //100-180
                             105, 84, 64, 46, 30, 17,  8,  2,  0,     //190-270
                               2,  8, 17, 30, 46, 64, 84, 105         //280-350
                           };

interrupt int_server( void)
{
//Alle wichtigen Register retten
 int_save_registers    // W, STATUS (and PCLATH)

//******************************
//PWM Timerinterrupt
//******************************
 if(TMR2IF) 
  {
   sbuf=data[shapecount];

   tmp=sbuf>>2;         //Bit 7..2 fr CCPR1L
   sbuf&=0x03;          //Bit 1,0 fr CCP1CON isolieren
   sbuf<<=4;            //und an die richtige Stelle schieben
   CCP1CON&=~0x30;      //alte Bits lschen
   CCP1CON|=sbuf;       //die unteren beiden Bits in CCP1CON
   CCPR1L=tmp;          //nur die sechs oberen Bits sind hier
   TMR2IF=0;            //Interruptflag lschen sonst
                        //Endlosinterrupt

   shapecount++; //Zhler fr PWM-Sinustabelle
   if(shapecount==SAMPLES) //Wenn alle Werte ausgegeben sind wieder vorne anfangen
    {
     shapecount=0;
    } 
  }
//Ende PWM Interrupt

//Alle wichtigen Register wiederherstellen
 int_restore_registers // W, STATUS (and PCLATH)
}
